DamageObject = Object:extend()

function DamageObject:new(x, y, width, height, radius, name, lifetime, bulletSpeedX)
    self.x = x
    self.y = y
    self.width = width
    self.height = height
    self.radius = radius
    self.name = name
    self.typemove = typemove
    self.lifetime = lifetime
    self.bulletSpeedX = bulletSpeedX
    
    if self.name == "cherrybomb" then
        self.sprite = love.graphics.newImage('cherrybomb.png')
        self.grid = anim8.newGrid(21, 21, self.sprite:getWidth(), self.sprite:getHeight())
        self.animation = anim8.newAnimation(self.grid('1-5', 1), 0.1)
        
        self.collider = world:newCircleCollider(self.x, self.y, self.radius)
        --self.collider = world:newRectangleCollider(self.x, self.y, self.width, self.height)
        self.collider:setCollisionClass('DamageObject')
        self.collider:setRestitution(0.8)
        self.collider:setObject(self)
        self.collider:applyLinearImpulse(self.bulletSpeedX, 70)
    end
    
    if self.name == "stomp" then
        self.sprite = love.graphics.newImage('stomp.png')
        self.grid = anim8.newGrid(40, 40, self.sprite:getWidth(), self.sprite:getHeight())
        self.animation = anim8.newAnimation(self.grid('1-8', 1), 0.1)
        
        --self.collider = world:newCircleCollider(self.x, self.y, self.radius)
        self.collider = world:newRectangleCollider(self.x, self.y, self.width, self.height)
        self.collider:setCollisionClass('DamageObject')
        self.collider:setObject(self)
    end
    
end

function DamageObject:update(dt)
    self.animation:update(dt)
    
    self.x = self.collider:getX()
    self.y = self.collider:getY()
    --self destroy (need to spit in a new function and make a real explosion)-finish
    
    if self.name == "cherrybomb" then
        if self.collider:enter('Frog') then
            local collision_data = self.collider:getEnterCollisionData('Frog')
            local enemy = collision_data.collider:getObject()
            print('yep')
            
            local xaxa = 0
            if enemy.collider:getX() < self.collider:getX() then
                xaxa = -100
            elseif enemy.collider:getX() > self.collider:getX() then
                xaxa = 100
            end
            
            enemy.collider:setLinearVelocity(xaxa, -100)
            enemy.health = enemy.health - 1
            table.insert(listOfExplo, EnemyExplosion(self.collider:getX(), self.collider:getY(), "eneExplo", 35))
            self:boom()
        end
    end
    if self.name == "stomp" then
        if self.collider:enter('Frog') then
            local collision_data = self.collider:getEnterCollisionData('Frog')
            local enemy = collision_data.collider:getObject()
            
            local xaxa = 0
            if enemy.collider:getX() < self.collider:getX() then
                xaxa = -100
            elseif enemy.collider:getX() > self.collider:getX() then
                xaxa = 100
            end
            
            enemy.collider:setLinearVelocity(xaxa, -100)
            table.insert(listOfExplo, EnemyExplosion(self.collider:getX(), self.collider:getY(), "eneExplo", 35))
            enemy.health = enemy.health - 1
        end
    end
    --
    self.lifetime = self.lifetime - 1
end

function DamageObject:boom()
    for dameObNum, ObjNow in ipairs(listOfDamageObject) do
        if ObjNow == self then 
            self.collider:destroy()
            table.remove(listOfDamageObject, dameObNum) 
                    
            break
        end
    end
end

function DamageObject:draw()
      self.animation:draw(self.sprite, self.x, self.y, nil, 1, 1, self.width/2, self.height/2)
end