function love.load()
    Object = require"classic"
    anim8 = require"anim8"
    
    wf = require'windfield'
    world = wf.newWorld(0, 0, true)
    world:setGravity(0, 512)
    
    world:addCollisionClass('Platform') 
    world:addCollisionClass('Frog')  
    world:addCollisionClass('DamageObject')
    world:addCollisionClass('Player')
    
    
    require"player"
    player = Player()
    
    require "wall"
    listOfWall = {}
    buildWall()
    
    require "frog"
    listOfFrog = {}
    table.insert(listOfFrog, Frog(350, 400, 3))
    table.insert(listOfFrog, Frog(450, 400, 3))
    table.insert(listOfFrog, Frog(400, 400, 3))
    table.insert(listOfFrog, Frog(445, 375, 3))
    table.insert(listOfFrog, Frog(425, 390, 3))
    
    table.insert(listOfFrog, Frog(350, 400, 3))
    table.insert(listOfFrog, Frog(450, 400, 3))
    table.insert(listOfFrog, Frog(400, 400, 3))
    table.insert(listOfFrog, Frog(445, 375, 3))
    table.insert(listOfFrog, Frog(425, 390, 3))
    
    table.insert(listOfFrog, Frog(350, 400, 3))
    table.insert(listOfFrog, Frog(450, 400, 3))
    table.insert(listOfFrog, Frog(400, 400, 3))
    table.insert(listOfFrog, Frog(445, 375, 3))
    table.insert(listOfFrog, Frog(425, 390, 3))
    
    require"enemyexplosion"
    listOfExplo = {}
    
    require"damageobject"
    listOfDamageObject = {}
    
    
    Camera = require'Camera'
    camera = Camera()
    camera:setFollowLerp(0.2)
    camera.scale = 2.5
    
end

function buildWall()
    for i=1, 11 do
        table.insert(listOfWall, Wall(200+i*48, 500))
    end
    table.insert(listOfWall, Wall(200-48, 500-48))
    table.insert(listOfWall, Wall(200-48, 500-48-48))
    table.insert(listOfWall, Wall(200-48-48, 500-48-48))
end

function love.update(dt)
    player:update(dt)
    world:update(dt)
    local xx, yy = player.collider:getLinearVelocity()
    -- camera effect made by myself
    if math.abs(yy) > 230 then
        if camera.scale > 1 then
            camera.scale = camera.scale - 0.05
        end
    else
        if camera.scale < 2.5 then
            camera.scale = camera.scale + 0.05
        end
    end
    --
    camera:update(dt)
    camera:follow(player.x, player.y)
    for i, v in ipairs(listOfFrog) do
        v:update(dt)
        
    end
    
    for exnum2, explonow2 in ipairs(listOfExplo) do
        explonow2:update(dt)
    end
    
    for DONum, DONow in ipairs(listOfDamageObject) do
        DONow:update(dt)
        if DONow.lifetime <= 0 then
        table.insert(listOfExplo, EnemyExplosion(DONow.collider:getX(), DONow.collider:getY(), "eneExplo", 35))
        DONow:boom()
        end
    end
    
end



function love.draw()
    camera:attach()
    
    player:draw()
    for i,v in ipairs(listOfWall) do
        v:draw()
    end
    for fronum,frogg in ipairs(listOfFrog) do
        frogg:draw()
        
    end
    
    for exnum, explonow in ipairs(listOfExplo) do
        explonow:draw()
    end
    
    for DONum2, DONow2 in ipairs(listOfDamageObject) do
        DONow2:draw()
    end
    world:draw()
    
    camera:detach()
    camera:draw()
end